
options linesize=88 pagesize=54;
options nonotes;
%include "sncftmshell.sas";

**SAMPLEDATA Data;
data sampledata(drop = i j k ahbp1-ahbp8 abmi1-abmi8);

    call streaminit(5027);
    
    do i=1 to 1000;
        baseage = int( 35 + 25*rand('uniform'));
        
        array ahbp(8);
        array abmi(8);
        array timearray(5) time_1 time_2 time_3 time_4 time_5;


        do j=1 to 8;
            ahbp(j) = (0.4>rand('uniform'));
            abmi(j) = log(25+5*(rand('normal')));
            end;
        
        do j=3 to 8 until (dia or censlost or censdead);
            id=i;
            time=j-3;
            do k=1 to 5;/*set time indicators*/
                if k=j-3 then timearray(k)=1;
                         else timearray(k)=0;
                end;


            hbp     = ahbp(j);
            hbp_l1  = ahbp(j-1);
            hbp_l2  = ahbp(j-2);
            hbp_b   = ahbp(2);

            bmi     = abmi(j);
            bmi_l1  = abmi(j-1);
            bmi_l2  = abmi(j-2);
            bmi_b   = abmi(2);

            dia = ( (j/500) >rand('uniform'));
            censlost  = (0.05>rand('uniform'));
            censdead  = (0.05>rand('uniform'));

            if bmi<=3.22 then A=1;
                         else A=0;
            if bmi_l1 <= 3.22 then A_l1=1;
                              else A_l1=0;
            if time=0 then do;
                if A_l1=1 then do;
                    Apreb=1;
                    A_l1=0;
                    end;
                else do;
                    Apreb=0;
                    end;
                end;    
                       
            output;

            end;
       end;
   
run;

proc means data=sampledata;
title 'Means of SAMPLEDATA data';
run;

/*CALL TO MACRO*/

%sncftmshell(
    data= sampledata,
    id=id,
    time=time,
    timepoints = 6,
    mintime=0,
    psionly=0,
    outc = dia,
    
    censdead = censdead,
    censlost = censlost,
    censpred = baseage hbp_b bmi_b time_1 time_2 time_3 time_4 time_5 hbp bmi bmi_l1, 
    weightdata=natcowts,

    nsamples = 10,
    blipup=yes,
    blipfunction=1,
    intlabel1= BMI <= 25,
    intlabel2= BMI > 25,

    treat1=A,
    treat1pred=baseage hbp_b bmi_b time_1 time_2 time_3 time_4 time_5 hbp bmi_l1 bmi_l2,
    seed= 741079,
    survcurv=_survgraph ,
    nointervdata = refdata 
    );

